#include "../../lib/std.mi"

Global Timer PauseTimer, space_timer, command_delay, song_timer;
Global Button Enabled;
Global Edit pause_time_string, threshold_percent, sec_from_end;
Global Double level, threshold, msec_from_end, pause_time;
Global Int song_length, space_length, cycle_flag, old_volume, string_counter, song_counter, repeat_state, pause_type;
Global String spaces, first_song, current_song;
Global Wac playlist;
Global Text info;

System.onScriptLoaded()
{
	 playlist = getWac("{45F3F7C1-A6F3-4EE6-A15E-125E92FC3F8D}");

	 Enabled = getscriptgroup().getObject("ActivePause");
	 pause_time_string = getscriptgroup().getObject("pause");
	 threshold_percent = getscriptgroup().getObject("level");
	 sec_from_end = getscriptgroup().getObject("sec_from_end");
	 info = getscriptgroup().getObject("info");

	 pause_time_string.setText(System.getPrivateString("EndSpace","pause_time_string", "0"));
	 threshold_percent.setText(System.getPrivateString("EndSpace","threshold_percent", "0"));
	 sec_from_end.setText(System.getPrivateString("EndSpace","sec_from_end", "0"));

	 PauseTimer = new Timer;
	 PauseTimer.stop();

	 space_timer = new Timer;
	 space_timer.stop();
	 space_timer.SetDelay(25);

	 command_delay = new Timer;
	 command_delay.stop();
	 command_delay.SetDelay(25);

	 song_timer = new Timer;
	 song_timer.stop();

}


Enabled.onLeftClick()
{
	 if(Enabled.getActivated())
	 {
	  	 Enabled.setActivated(0);
	  	 playlist.sendCommand("repeat",repeat_state, 0,"");
		 system.SetVolume(old_volume);
	 }
	 else
	 {
	    Enabled.setActivated(1);
	    repeat_state = Playlist.sendCommand("get_repeat", 0, 0,"");
	    old_volume = system.getVolume();

	    cycle_flag = 0;
	 	threshold = 0;
	 	space_length = 0;
	 	msec_from_end = 0;
	 	pause_time = 0;
	 	cycle_flag = 0;
	 	song_counter = 0;
	 	string_counter = 0;
	 	spaces = " ";

	 	song_timer.stop();
	 	command_delay.stop();
	 	PauseTimer.stop();
	 	space_timer.stop();

	 }

}


System.onStop()
{

	if(enabled.getActivated())
	{
	  	 Enabled.setActivated(0);
	  	 playlist.sendCommand("repeat",repeat_state, 0,"");
		 system.SetVolume(old_volume);
	}

}



System.onPlay()
{


	 if(enabled.getActivated())
	 {
		space_timer.stop();

		if (song_counter == 0)
		{
			repeat_state = Playlist.sendCommand("get_repeat", 0, 0,"");
			playlist.sendCommand("repeat",1, 0,"");
	 		first_song = system.getPlayItemString();
	 		old_volume = system.getVolume();

	 	}

	 	else if (first_song == system.getPlayItemString())
	 	{
	 		system.SetVolume(old_volume);
	 		cycle_flag = cycle_flag + 1;
	 		if (cycle_flag == 1)spaces = spaces +  integerToString(space_length) + ",";
	 		pause_type = 0;
	 	}

	 	song_length = system.getPlayItemLength();

	 	if (cycle_flag == 0)
		{
			system.SetVolume(0);

			threshold = (System.StringToFloat(threshold_percent.gettext())*2.55);
			msec_from_end = (System.StringToFloat(sec_from_end.gettext())*1000);

			spaces = spaces +  integerToString(space_length) + ",";

			song_counter = song_counter + 1;

			command_delay.start();
		}
		else if (cycle_flag == 1)
		{
			string_counter = string_counter + 1;

			current_song = system.getPlayItemString();


			if (pause_type == 1)
			{
				System.Pause();

				song_timer.Stop();

				pause_time = (System.StringToFloat(pause_time_string.gettext()))*1000;
				pausetimer.SetDelay(pause_time);

				PauseTimer.start();

			}
			else
			{

				space_length = stringToInteger(System.getToken(spaces, ",", string_counter));
				song_timer.SetDelay(song_length - space_length);

				info.setText(integerToString(space_length));

				song_timer.start();
				pause_type = 1;

			}


		}

		else if (cycle_flag > 1)
		{
			System.Pause();
			cycle_flag = 2;
			command_delay.start();
		}


	  }


}


PauseTimer.onTimer()
{
	PauseTimer.stop();

	if (pause_type == 1)
	{
		System.Pause();
		space_length = stringToInteger(System.getToken(spaces, ",", string_counter));
		song_timer.SetDelay(song_length - space_length);

		info.setText(integerToString(space_length));

		song_timer.start();
		pause_type = 1;

	}
	else
	{
		System.Pause();
		System.Next();
	}

}



song_timer.onTimer()
{
	song_timer.Stop();

	if (current_song != system.getPlayItemString())
	{
		pause_type = 1;
	}
	else
	{
		System.Pause();

		pause_time = (System.StringToFloat(pause_time_string.gettext()))*1000;
		pausetimer.SetDelay(pause_time);
		pause_type = 0;
		PauseTimer.start();
	}

}


command_delay.onTimer()
{
	command_delay.stop();

	if (cycle_flag == 0)
	{

	System.seekTo(song_length-msec_from_end);

	space_length = 0;
	space_timer.start();
	}
	else if (cycle_flag == 2)
	{
		System.Stop();
	}


}



space_timer.onTimer()
{
	 level = (system.getRightVuMeter() + system.getLeftVuMeter())/2;

	 If (level <= threshold)
	 {
	 	space_length = space_length + 25;
	 }
	 else
	 {
	 	space_length = 0;
	 }


}


System.onScriptUnloading()
{
  delete PauseTimer;
  delete space_timer;
  delete song_timer;
  delete command_delay;
  System.setPrivateString("EndSpace", "pause_time_string", (pause_time_string.gettext()));
  System.setPrivateString("EndSpace", "threshold_percent", (threshold_percent.gettext()));
  System.setPrivateString("EndSpace", "sec_from_end", (sec_from_end.gettext()));
}

