//-----------------------------------
// original script by Gonzotek
// edited by ThePlague (Linus Brolin)
// with help/idea from The Rhino
//-----------------------------------

#include "../../../lib/std.mi"

Function String tokenizeSongInfo(String tkn, String sinfo);

Global GuiObject mono, stereo;
Global Text bitrateText, infolineExampleText, channelsText, FrequencyText, abrText;
Global Layout Main;
Global Timer songInfoTimer;
Global String SongInfoString;

System.onScriptLoaded()
{
Main = getContainer("Main").getLayout("Normal");
mono = Main.getObject("mono-led-on");
stereo = Main.getObject("stereo-led-on");
infolineExampleText = Main.getObject("infolinexample");
bitrateText = Main.getObject("Bitrate");
abrText = Main.getObject("ABR");
channelsText = Main.getObject("Channels");
frequencyText = Main.getObject("Frequency");
songInfoTimer = new Timer;
songInfoTimer.setDelay(1);
if (getLeftVUMeter()) songInfoTimer.start();
mono.hide(); 
stereo.hide(); 
}

System.onScriptUnloading(){
	delete songInfoTimer;
}

System.onPlay(){
	songInfoTimer.start();
}

System.onStop(){
	songInfoTimer.stop();
	frequencyText.setText("");
	bitrateText.setText("");
        mono.hide(); 
        stereo.hide(); 
}

System.onResume(){
	songInfoTimer.start();
}

System.onPause(){
	songInfoTimer.stop();
}

songInfoTimer.onTimer(){
String tkn;
	SongInfoString = infolineExampleText.getText();

	tkn = tokenizeSongInfo("Bitrate", SongInfoString);
	bitrateText.setText(tkn);

	tkn = tokenizeSongInfo("ABR", SongInfoString);
	abrText.setText(tkn);

	tkn = tokenizeSongInfo("Channels", SongInfoString);
	channelsText.setText(tkn);

	tkn = tokenizeSongInfo("Frequency", SongInfoString);
	frequencyText.setText(tkn);
}

tokenizeSongInfo(String tkn, String sinfo){
int searchResult;
String rtn;
if (tkn=="Bitrate"){
		for (int i = 0; i < 5; i++) {
			rtn = getToken(sinfo, " ", i);
			searchResult = strsearch(rtn, "kbps");
			if (searchResult>0) return Strleft(rtn, 3);
		}
		return "";
}
if (tkn=="Channels"){
		for (int i = 0; i < 5; i++) {
			rtn = getToken(sinfo, " ", i);
			searchResult = strsearch(rtn, "tereo");
			stereo.show();
			mono.hide(); 
			if (searchResult>0) return rtn;
			searchResult = strsearch(rtn, "ono");
			mono.show();
			stereo.hide(); 
			if (searchResult>0) return rtn;
		}
		return "";
}
if (tkn=="Frequency"){
		for (int i = 0; i < 5; i++) {
			rtn = getToken(sinfo, " ", i);
			searchResult = strsearch(rtn, "kHz");
			if (searchResult>0) return Strleft(rtn, 2);
		}
		return "";
}
if (tkn=="ABR"){
		for (int i = 0; i < 5; i++) {
			rtn = getToken(sinfo, " ", i);
			searchResult = strsearch(rtn, "bps)");
			if (searchResult>0) return rtn;
		}
		return "";
}


else return "";
}