//Eq Spline Tension Script
//By Eric Moore
// 3-30-02

#include "../../lib/std.mi"

#define e (2.71828182846)
#define FAR_X (-2.25)  
#define NEAR_X (-1)     

//FAR_X larger x-coord of the gaussian (already squared e^-x^2)
//NEAR_X smaller x-coord ""

global slider eq0, eq1, eq2, eq3, eq4, eq5, eq6, eq7, eq8, eq9;
global int b0, b1, b2, b3, b4, b5, b6, b7, b8, b9;

system.onscriptloaded()
{
	layout eq = getContainer("equalizer").getLayout("eq");
	eq0 = eq.getObject("eq1");
	eq1 = eq.getObject("eq2");
	eq2 = eq.getObject("eq3");
	eq3 = eq.getObject("eq4");
	eq4 = eq.getObject("eq5");
	eq5 = eq.getObject("eq6");
	eq6 = eq.getObject("eq7");
	eq7 = eq.getObject("eq8");
	eq8 = eq.getObject("eq9");
	eq9 = eq.getObject("eq10");
	
	b0 = system.geteqband(0);
	b1 = system.geteqband(1);
	b2 = system.geteqband(2);
	b3 = system.geteqband(3);
	b4 = system.geteqband(4);
	b5 = system.geteqband(5);
	b6 = system.geteqband(6);
	b7 = system.geteqband(7);
	b8 = system.geteqband(8);
	b9 = system.geteqband(9);
}

eq0.onsetposition(int newpos)
{
	if(b0 <= newpos-134 || b0 >= newpos-122) 
	{
		int pos = geteqband(0);
		seteqband(1,b1+(pos*pow(e,NEAR_X)));
		seteqband(2,b2+(pos*pow(e,FAR_X)));
	}
}
eq0.onsetfinalposition(int newpos)
{
	if(b0 <= newpos-134 || b0 >= newpos-122)
	{
		b0 = geteqband(0);
		b1 = geteqband(1);
		b2 = geteqband(2);
	}
}	

eq1.onsetposition(int newpos)
{
	if(b1 <= newpos-134 || b1 >= newpos-122)
	{
		int pos = geteqband(1);
		seteqband(0,b0+(pos*pow(e,NEAR_X)));
		seteqband(2,b2+(pos*pow(e,NEAR_X)));
		seteqband(3,b3+(pos*pow(e,FAR_X)));
	}
}	
eq1.onsetfinalposition(int newpos)
{
	if(b1 <= newpos-134 || b1 >= newpos-122)
	{
		b0 = geteqband(0);
		b1 = geteqband(1);
		b2 = geteqband(2);
		b3 = geteqband(3);
	}
}

eq2.onsetposition(int newpos)
{
	if(b2 <= newpos-134 || b2 >= newpos-122)
	{
		int far = geteqband(2)*pow(e,FAR_X);
		int near = geteqband(2)*pow(e,NEAR_X);
		seteqband(0,b0+far);
		seteqband(1,b1+near);
		seteqband(3,b3+near);
		seteqband(4,b4+far);
	}
}
eq2.onsetfinalposition(int newpos)
{
	if(b2 <= newpos-134 || b2 >= newpos-122)
	{
		b0 = geteqband(0);
		b1 = geteqband(1);
		b2 = geteqband(2);
		b3 = geteqband(3);
		b4 = geteqband(4);
	}
}

eq3.onsetposition(int newpos)
{
	if(b3 <= newpos-134 || b3 >= newpos-122)
	{
		int far = geteqband(3)*pow(e,FAR_X);
		int near = geteqband(3)*pow(e,NEAR_X);
		seteqband(1,b1+far);
		seteqband(2,b2+near);
		seteqband(4,b3+near);
		seteqband(5,b4+far);
	}
}
eq3.onsetfinalposition(int newpos)
{
	if(b3 <= newpos-134 || b3 >= newpos-122)
	{
		b1 = geteqband(1);
		b2 = geteqband(2);
		b3 = geteqband(3);
		b4 = geteqband(4);
		b5 = geteqband(5);
	}
}

eq4.onsetposition(int newpos)
{
	if(b4 <= newpos-134 || b4 >= newpos-122)
	{
		int far = geteqband(4)*pow(e,FAR_X);
		int near = geteqband(4)*pow(e,NEAR_X);
		seteqband(2,b2+far);
		seteqband(3,b3+near);
		seteqband(5,b5+near);
		seteqband(6,b6+far);
	}
}
eq4.onsetfinalposition(int newpos)
{
	if(b4 <= newpos-134 || b4 >= newpos-122)
	{
		b2 = geteqband(2);
		b3 = geteqband(3);
		b4 = geteqband(4);
		b5 = geteqband(5);
		b6 = geteqband(6);
	}
}

eq5.onsetposition(int newpos)
{
	if(b5 <= newpos-134 || b5 >= newpos-122)
	{
		int far = geteqband(5)*pow(e,FAR_X);
		int near = geteqband(5)*pow(e,NEAR_X);
		seteqband(3,b3+far);
		seteqband(4,b4+near);
		seteqband(6,b6+near);
		seteqband(7,b7+far);
	}
}
eq5.onsetfinalposition(int newpos)
{
	if(b5 <= newpos-134 || b5 >= newpos-122)
	{
		b3 = geteqband(3);
		b4 = geteqband(4);
		b5 = geteqband(5);
		b6 = geteqband(6);
		b7 = geteqband(7);
	}
}

eq6.onsetposition(int newpos)
{
	if(b6 <= newpos-134 || b6 >= newpos-122)
	{
		int far = geteqband(6)*pow(e,FAR_X);
		int near = geteqband(6)*pow(e,NEAR_X);
		seteqband(4,b4+far);
		seteqband(5,b5+near);
		seteqband(7,b7+near);
		seteqband(8,b8+far);
	}
}
eq6.onsetfinalposition(int newpos)
{
	if(b6 <= newpos-134 || b6 >= newpos-122)
	{
		b4 = geteqband(4);
		b5 = geteqband(5);
		b6 = geteqband(6);
		b7 = geteqband(7);
		b8 = geteqband(8);
	}
}

eq7.onsetposition(int newpos)
{
	if(b7 <= newpos-134 || b7 >= newpos-122)
	{
		int far = geteqband(7)*pow(e,FAR_X);
		int near = geteqband(7)*pow(e,NEAR_X);
		seteqband(5,b5+far);
		seteqband(6,b6+near);
		seteqband(8,b8+near);
		seteqband(9,b9+far);
	}
}
eq7.onsetfinalposition(int newpos)
{
	if(b7 <= newpos-134 || b7 >= newpos-122)
	{
		b5 = geteqband(5);
		b6 = geteqband(6);
		b7 = geteqband(7);
		b8 = geteqband(8);
		b9 = geteqband(9);
	}
}
	
eq8.onsetposition(int newpos)
{
	if(b8 <= newpos-134 || b8 >= newpos-122)
	{
		int pos = geteqband(8);
		seteqband(6,b6+(pos*pow(e,FAR_X)));
		seteqband(7,b7+(pos*pow(e,NEAR_X)));
		seteqband(9,b9+(pos*pow(e,NEAR_X)));
	}
}
eq8.onsetfinalposition(int newpos)
{
	if(b8 <= newpos-134 || b8 >= newpos-122)
	{
		b6 = geteqband(6);
		b7 = geteqband(7);
		b8 = geteqband(8);
		b9 = geteqband(9);
	}
}

eq9.onsetposition(int newpos)
{
	if(b9 <= newpos-134 || b9 >= newpos-122)
	{
		int pos = geteqband(9);
		seteqband(7,b7+(pos*pow(e,FAR_X)));
		seteqband(8,b8+(pos*pow(e,NEAR_X)));
	}
}
eq9.onsetfinalposition(int newpos)
{
	if(b9 <= newpos-134 || b9 >= newpos-122)
	{
		b7 = geteqband(7);
		b8 = geteqband(8);
		b9 = geteqband(9);
	}
}
	
	